panelapp/api/urls.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django.urls import path, include
from django.conf import settings
from drf_yasg.views import get_schema_view
from drf_yasg import openapi
from .permissions import ReadOnlyPermissions

schema_view = get_schema_view(
    openapi.Info(
        title="PanelApp API",
        default_version=settings.REST_FRAMEWORK["DEFAULT_VERSION"],
        description="PanelApp API",
        terms_of_service="https://panelapp.genomicsengland.co.uk/policies/terms/",
        contact=openapi.Contact(email="panelapp@genomicsengland.co.uk"),
        license=openapi.License(name="MIT License"),
    ),
    patterns=["api"],
    validators=["flex", "ssv"],
    public=True,
    permission_classes=(ReadOnlyPermissions,),
)

app_name = "api"
urlpatterns = [path("v1/", include("api.v1.urls", namespace="v1"))]

panelapp/panels/urls.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django.conf.urls import url

from django.views.generic import RedirectView
from .views import AdminView
from .views import AdminUploadGenesView
from .views import AdminUploadPanelsView
from .views import AdminUploadReviewsView
from .views import EntitiesListView
from .views import CreatePanelView
from .views import EntityDetailView
from .views import GenePanelView
from .views import PanelsIndexView
from .views import UpdatePanelView
from .views import PromotePanelView
from .views import PanelAddEntityView
from .views import PanelEditEntityView
from .views import PanelMarkNotReadyView
from .views import GenePanelSpanshotView
from .views import EntityReviewView
from .views import MarkEntityReadyView
from .views import DownloadPanelTSVView
from .views import DownloadPanelVersionTSVView
from .views import MarkGeneNotReadyView
from .views import ComparePanelsView
from .views import CompareGeneView
from .views import CopyReviewsView
from .views import DownloadAllGenes
from .views import DownloadAllPanels
from .views import ActivityListView
from .views import DownloadAllSTRs
from .views import DownloadAllRegions
from .views import GeneDetailRedirectView
from .views import RedirectGenesToEntities
from .views import OldCodeURLRedirect
from .ajax_views import ClearPublicationsAjaxView
from .ajax_views import ClearPhoenotypesAjaxView
from .ajax_views import ClearModeOfPathogenicityAjaxView
from .ajax_views import ClearSourcesAjaxView
from .ajax_views import ClearSingleSourceAjaxView
from .ajax_views import DeletePanelAjaxView
from .ajax_views import DeleteEntityAjaxView
from .ajax_views import RejectPanelAjaxView
from .ajax_views import ApprovePanelAjaxView
from .ajax_views import UpdateEntityTagsAjaxView
from .ajax_views import UpdateEntityMOPAjaxView
from .ajax_views import UpdateEntityMOIAjaxView
from .ajax_views import UpdateEntityPhenotypesAjaxView
from .ajax_views import UpdateEntityPublicationsAjaxView
from .ajax_views import UpdateEntityRatingAjaxView
from .ajax_views import DeleteEntityEvaluationAjaxView
from .ajax_views import GetEntityCommentFormAjaxView
from .ajax_views import DeleteEntityCommentAjaxView
from .ajax_views import SubmitEntityCommentFormAjaxView
from .ajax_views import ApproveEntityAjaxView


app_name = "panels"

entity_regex = "[\w\-\.\$\~\@\#\ ]+"
entity_types = "gene|str|region"

urlpatterns = [
    url(r"^$", PanelsIndexView.as_view(), name="index"),
    url(r"^compare/$", ComparePanelsView.as_view(), name="compare_panels_form"),
    url(
        r"^compare/(?P<panel_1_id>[0-9]+)/(?P<panel_2_id>[0-9]+)$",
        ComparePanelsView.as_view(),
        name="compare",
    ),
    url(
        r"^compare/(?P<panel_1_id>[0-9]+)/(?P<panel_2_id>[0-9]+)/(?P<gene_symbol>[\w\-]+)$",
        CompareGeneView.as_view(),
        name="compare_genes",
    ),
    url(
        r"^copy/(?P<panel_1_id>[0-9]+)/(?P<panel_2_id>[0-9]+)$",
        CopyReviewsView.as_view(),
        name="copy_reviews",
    ),
    url(r"^(?P<pk>[0-9]+)/$", GenePanelView.as_view(), name="detail"),
    url(r"^(?P<pk>[0-9]+)/update$", UpdatePanelView.as_view(), name="update"),
    url(r"^(?P<pk>[0-9]+)/promote$", PromotePanelView.as_view(), name="promote"),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/add".format(types=entity_types),
        PanelAddEntityView.as_view(),
        name="add_entity",
    ),
    url(r"^(?P<pk>[0-9]+)/delete$", DeletePanelAjaxView.as_view(), name="delete_panel"),
    url(r"^(?P<pk>[0-9]+)/reject$", RejectPanelAjaxView.as_view(), name="reject_panel"),
    url(
        r"^(?P<pk>[0-9]+)/approve$",
        ApprovePanelAjaxView.as_view(),
        name="approve_panel",
    ),
    url(
        r"^(?P<pk>[0-9]+)/download/(?P<categories>[0-4]+)/$",
        DownloadPanelTSVView.as_view(),
        name="download_panel_tsv",
    ),
    url(
        r"^(?P<pk>[0-9]+)/download_version/$",
        DownloadPanelVersionTSVView.as_view(),
        name="download_old_panel_tsv",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_name>{})/$".format(entity_regex),
        RedirectGenesToEntities.as_view(),
        name="redirect_previous_structure",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/$".format(
            types=entity_types, regex=entity_regex
        ),
        GenePanelSpanshotView.as_view(),
        name="evaluation",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/edit$".format(
            types=entity_types, regex=entity_regex
        ),
        PanelEditEntityView.as_view(),
        name="edit_entity",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/review$".format(
            types=entity_types, regex=entity_regex
        ),
        EntityReviewView.as_view(),
        name="review_entity",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/mark_as_ready$".format(
            types=entity_types, regex=entity_regex
        ),
        MarkEntityReadyView.as_view(),
        name="mark_entity_as_ready",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/mark_as_not_ready$".format(
            types=entity_types, regex=entity_regex
        ),
        MarkGeneNotReadyView.as_view(),
        name="mark_entity_as_not_ready",
    ),
    # AJAX endpoints
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/delete$".format(
            types=entity_types, regex=entity_regex
        ),
        DeleteEntityAjaxView.as_view(),
        name="delete_entity",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/approve$".format(
            types=entity_types, regex=entity_regex
        ),
        ApproveEntityAjaxView.as_view(),
        name="approve_entity",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_sources$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearSourcesAjaxView.as_view(),
        name="clear_entity_sources",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_source/(?P<source>(.*))/$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearSingleSourceAjaxView.as_view(),
        name="clear_entity_source",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_phenotypes$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearPhoenotypesAjaxView.as_view(),
        name="clear_entity_phenotypes",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_publications$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearPublicationsAjaxView.as_view(),
        name="clear_entity_publications",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/clear_entity_mode_of_pathogenicity$".format(
            types=entity_types, regex=entity_regex
        ),
        ClearModeOfPathogenicityAjaxView.as_view(),
        name="clear_entity_mode_of_pathogenicity",
    ),
    # AJAX Review endpoints
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_tags/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityTagsAjaxView.as_view(),
        name="update_entity_tags",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_rating/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityRatingAjaxView.as_view(),
        name="update_entity_rating",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_moi/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityMOIAjaxView.as_view(),
        name="update_entity_moi",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_mop/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityMOPAjaxView.as_view(),
        name="update_entity_mop",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_phenotypes/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityPhenotypesAjaxView.as_view(),
        name="update_entity_phenotypes",
    ),
    url(
        r"^(?P<pk>[0-9]+)/(?P<entity_type>({types}))/(?P<entity_name>{regex})/update_entity_publications/$".format(
            types=entity_types, regex=entity_regex
        ),
        UpdateEntityPublicationsAjaxView.as_view(),
        name="update_entity_publications",
    ),
    url(

panelapp/panels/models/codes.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
"""Enums used in the app"""

from enum import Enum


class ProcessingRunCode(Enum):
    PROCESSED = 0
    PROCESS_BACKGROUND = 1

panelapp/panels/forms/activity.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django import forms


class ActivityFilterForm(forms.Form):
    panel = forms.ChoiceField(required=False, choices=list)
    version = forms.ChoiceField(required=False, choices=list)
    entity = forms.ChoiceField(
        label="Gene or Genomic Entity Name", required=False, choices=list
    )
    date_from = forms.DateField(
        required=False,
        widget=forms.DateInput(
            attrs={
                "type": "date",
                "placeholder": "Date in YYYY-MM-DD format",
                "pattern": "[0-9]{4}-[0-9]{2}-[0-9]{2}",
            }
        ),
    )
    date_to = forms.DateField(
        required=False,
        widget=forms.DateInput(
            attrs={
                "type": "date",
                "placeholder": "Date in YYYY-MM-DD format",
                "pattern": "[0-9]{4}-[0-9]{2}-[0-9]{2}",
            }
        ),
    )

    def __init__(self, *args, **kwargs):
        panels = kwargs.pop("panels")
        versions = kwargs.pop("versions")
        entities = kwargs.pop("entities")

        super().__init__(*args, **kwargs)

        self.fields["panel"].choices = [("", "Panel")] + list(panels)

        if versions:
            self.fields["version"].choices = [("", "Panel Version")] + list(versions)
        else:
            self.fields["version"].widget.attrs = {"disabled": "disabled"}

        if entities:
            self.fields["entity"].choices = [("", "")] + list(entities)
        else:
            self.fields["entity"].widget.attrs = {"disabled": "disabled"}

panelapp/panels/forms/geneready.py
##
## Copyright (c) 2016-2019 Genomics England Ltd.
##
## This file is part of PanelApp
## (see https://panelapp.genomicsengland.co.uk).
##
## Licensed to the Apache Software Foundation (ASF) under one
## or more contributor license agreements.  See the NOTICE file
## distributed with this work for additional information
## regarding copyright ownership.  The ASF licenses this file
## to you under the Apache License, Version 2.0 (the
## "License"); you may not use this file except in compliance
## with the License.  You may obtain a copy of the License at
##
##   http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing,
## software distributed under the License is distributed on an
## "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
## KIND, either express or implied.  See the License for the
## specific language governing permissions and limitations
## under the License.
##
from django import forms
from panels.models import GenePanelEntrySnapshot


class GeneReadyForm(forms.ModelForm):
    """
    This class marks Gene as Ready and also adds a comment if it was provided.
    It also saves a new evidence with the current Gene status as an evidence.
    Additionally, we add save a TrackRecord to note this change, and record an activity
    """

    ready_comment = forms.CharField(
        label="Comment (eg What decisions are being made?)",
        required=False,
        widget=forms.Textarea,
    )

    class Meta:
        model = GenePanelEntrySnapshot
        fields = ("comments",)

    def __init__(self, *args, **kwargs):
        self.request = kwargs.pop("request")
        super().__init__(*args, **kwargs)

        original_fields = self.fields
        self.fields = {}
        self.fields["ready_comment"] = original_fields.get("ready_comment")

    def save(self, *args, **kwargs):
        self.instance.mark_as_ready(
            self.request.user, self.cleaned_data["ready_comment"]
        )

panelapp/panels/templates/panels/entity/edit_comment.html
{% load bootstrap3 %}
<form action="{% url 'panels:submit_edit_comment_by_user' panel_id entity_type entity_name comment_pk %}#your-review" method="post" class="form">
  {% csrf_token %}
  {% for field in edit_comment_form %}
    <span class="rm">{{ field.label_tag }}</span>
    <div class="add-label-margin">{% bootstrap_field field show_label=False %}</div>
  {% endfor %}
  <input type="submit" class="btn btn-info" value="Save Changes">
</form>

panelapp/panels/templates/panels/entity/evaluation_create.html
{% extends "default.html" %}
{% load static %}
{% load staticfiles %}
{% load bootstrap3 %}

{% block content %}
<ol class="breadcrumb">
    <li>
        <a href="{% url 'panels:index' %}">Panels</a>
    </li>
    <li>
        <a href="{{ view.panel.get_absolute_url }}">
            {{ view.panel.level4title.name }}
        </a>
    </li>
    <li>
        <a href="{% url 'panels:evaluation' view.panel.panel.id entity_type entity_name %}">
            {{ entity_name }}
        </a>
    </li>
    <li class="active">
        Add review
    </li>
</ol>

<h1>
    {% block title %}Review {% if entity_type == 'gene' %}gene{% elif entity_type == 'str' %}STR{% elif entity_type == 'region' %}Region{% endif %}{% endblock %}
</h1>

{% if request.user.is_authenticated and request.user.reviewer.is_verified %}
    <form class="row add-top-margin remove-empty-array-val" id="evaluation-create" method="post">
        {% csrf_token %}
        <div class="col-md-8">
            <div class="well">
                <fieldset>
                    {% for field in form %}
                        <div class="form-group">
                            {% if field.errors %}
                                {% for error in field.errors %}
                                    <span class="label label-danger">{{ error|escape }}</span>
                                {% endfor %}
                            {% endif %}

                            {% if field.name == "mode_of_pathogenicity" %}
                                {{ field.label_tag }} <a data-toggle="modal" data-target="#model_of_path" ><i class="fa fa-question-circle"></i></a>
                            {% elif field.name == "Model_of_inheritance" %}
                                {{ field.label_tag }} <a data-toggle="modal" data-target="#moi" ><i class="fa fa-question-circle"></i></a>
                            {% elif field.name == "rating" %}
                                <hr />
                                <h4 class="add-label-margin">Review gene</h4>
                                <p class="text-muted">You can optionally include a review of this gene when you add it.</p>
                                {{ field.label_tag }}
                            {% elif field.name == "current_diagnostic" %}
                                {{ field.label_tag }} <a data-toggle="modal" data-target="#diagostic" ><i class="fa fa-question-circle"></i></a>
                            {% else %}
                                {{ field.label_tag }}
                            {% endif %}

                            {% bootstrap_field field show_label=False %}
                        </div>
                    {% endfor %}
                    <button type="submit" class="btn btn-primary">Add review</button>
                </fieldset>
            </div>
        </div>
    </form>
    {{ form.media }}
    {% block modals %}
        {% include "panels/modals/rating.html" %}
        {% include "panels/modals/mode_of_path.html" %}
        {% include "panels/modals/diagnostic.html" %}
        {% include "panels/modals/mode_of_inheritance.html" %}
    {% endblock %}
{% endif %}
{% endblock %}

panelapp/panels/templates/panels/entity/evaluation_genes_list.html
{% load panel_helpers %}

<div class="panel-heading">Genes in panel</div>
<div class="btn-group btn-group-justified" role="group" data-module="gene-nav">
    {% if prev_gene %}
        <a href="{% url 'panels:evaluation' panel.panel_id 'gene' prev_gene.gene.gene_symbol %}"
           class="gene-nav-prev btn btn-default" title="{{ prev_gene.gene.gene_symbol }}">
            <i class="fa fa-arrow-up add-right-margin"></i>Prev
        </a>
    {% else %}
        <span class="gene-nav-prev btn btn-default disabled">
            <i class="fa fa-arrow-up add-right-margin"></i>Prev
        </span>
    {% endif %}
    {% if next_gene %}
        <a href="{% url 'panels:evaluation' panel.panel_id 'gene' next_gene.gene.gene_symbol %}"
           class="gene-nav-next btn btn-default" title="{{ next_gene.gene.gene_symbol }}">
            Next<i class="fa fa-arrow-down add-left-margin"></i>
        </a>
    {% else %}
        <span class="gene-nav-next btn btn-default disabled">
            Next<i class="fa fa-arrow-down add-left-margin"></i>
        </span>
    {% endif %}
</div>
<ul class="list-group" data-module="gene-nav" id="gene-nav">
  {% for entry in panel_genes %}
    <li
        class="list-group-item {% if entity.gene.gene_symbol == entry.gene.gene_symbol %}list-group-item-active{% endif %}"
        {% if entity.gene.gene_symbol == entry.gene.gene_symbol %}id="gene-nav-active-item"{% endif %}
    >
      <a href="{% url 'panels:evaluation' panel.panel_id 'gene' entry.gene.gene_symbol %}{% if entry.gene.gene_symbol in panel.current_genes_duplicates %}?pk={{ entry.pk }}{% endif %}">
      {% if request.user.pk in entry.evaluators %}
          <i
              class="fa fa-check-circle {{ entry|gene_list_class }} add-right-margin gel-badge pull-left"
              data-toggle="tooltip"
              title="You have reviewed"
          ></i>
      {% else %}
          <i
              class="fa fa-circle gel-badge add-right-margin pull-left {{ entry|gene_list_class }}"
              data-toggle="tooltip"
              title="{{ entry|gene_list_name }}"
          ></i>
      {% endif %}
      {{ entry.gene.gene_symbol }}
      <span
          class="pull-right text-muted"
          data-toggle="tooltip"
          data-placement="left"
          title="{{ entry.number_of_evaluations }} review{{entry.number_of_evaluations|pluralize}}"
      >{{ entry.number_of_evaluations }}</span>
      </a>

    </li>
  {% endfor %}

</ul>
{% if request.user.is_authenticated and request.user.reviewer.is_verified %}
    <ul class="list-group">
        <li class="list-group-item" style="border-top: none">
            <a href="{% url 'panels:add_entity' panel.panel_id 'gene' %}">
                <i class="fa fa-plus add-right-margin"></i>Add a gene
            </a>
        </li>
    </ul>
{% endif %}

panelapp/panels/templates/panels/entity/evaluation_regions_list.html
{% load panel_helpers %}

<div class="panel-heading">Regions in panel</div>
<div class="btn-group btn-group-justified" role="group" data-module="gene-nav">
    {% if prev_region %}
        <a href="{{ prev_region.get_absolute_url }}"
           class="gene-nav-prev btn btn-default" title="{{ prev_region.label }}">
            <i class="fa fa-arrow-up add-right-margin"></i>Prev
        </a>
    {% else %}
        <span class="gene-nav-prev btn btn-default disabled">
            <i class="fa fa-arrow-up add-right-margin"></i>Prev
        </span>
    {% endif %}
    {% if next_region %}
        <a href="{{ next_region.get_absolute_url }}"
           class="gene-nav-next btn btn-default" title="{{ next_region.label }}">
            Next<i class="fa fa-arrow-down add-left-margin"></i>
        </a>
    {% else %}
        <span class="gene-nav-next btn btn-default disabled">
            Next<i class="fa fa-arrow-down add-left-margin"></i>
        </span>
    {% endif %}
</div>
<ul class="list-group" data-module="gene-nav" id="gene-nav">
  {% for entry in panel_regions %}
    <li
        class="list-group-item {% if entity == entry %}list-group-item-active{% endif %}"
        {% if entity == entry %}id="gene-nav-active-item"{% endif %}
    >
      <a
         href="{% url 'panels:evaluation' panel.panel_id 'region' entry.name %}{% if entry.name in panel.current_genes_duplicates %}?pk={{ entry.pk }}{% endif %}"
         title="{{ entry.verbose_name }}"
      >
      {% if request.user.pk in entity.evaluators %}
          <i
              class="fa fa-check-circle {{ entity|gene_list_class }} add-right-margin gel-badge pull-left"
              data-toggle="tooltip"
              title="You have reviewed"
          ></i>
      {% else %}
          <i
              class="fa fa-circle gel-badge add-right-margin pull-left {{ entry|gene_list_class }}"
              data-toggle="tooltip"
              title="{{ entry|gene_list_name }}"
          ></i>
      {% endif %}
      {{ entry.verbose_name }}<br />
      {{ entry.name }}
      <span
          class="pull-right text-muted"
          data-toggle="tooltip"
          data-placement="left"
          title="{{ entity.number_of_evaluations }} review{{entry.number_of_evaluations|pluralize}}"
      >{{ entry.number_of_evaluations }}</span>
      </a>

    </li>
  {% endfor %}

</ul>
{% if request.user.is_authenticated and request.user.reviewer.is_verified %}
    <ul class="list-group">
        <li class="list-group-item" style="border-top: none">
            <a href="{% url 'panels:add_entity' panel.panel_id 'region' %}">
                <i class="fa fa-plus add-right-margin"></i>Add a Region
            </a>
        </li>
    </ul>
{% endif %}

panelapp/panels/templates/panels/entity/evaluation_update.html
{% extends "default.html" %}
{% load static %}
{% load staticfiles %}

{% block content %}
<ol class="breadcrumb">
    <li>
        <a href="{% url 'panels:index' %}">Panels</a>
    </li>
    <li>
        <a href="{% url 'panels:detail' panel.pk  %}">
            {{ panel.level4title.name }}
        </a>
    </li>
    <li>
        <a href="{% url 'panels:evaluation' panel.pk entity_type entity_name  %}">
            {{ entity.name }}
        </a>
    </li>
    <li class="active">
        Review {{ entity.label }}
    </li>
</ol>

<h1>
    {% block title %}Review {{ entity.label }} in panel {{ panel.level4title.name }}{% endblock %}
</h1>

{% if request.user.is_authenticated and request.user.reviewer.is_verified %}
{% include "panels/entity/evaluation_form.html" %}
{% endif %}
{% endblock %}